package ru.dbotthepony.kstarbound.defs.item.impl

import com.google.common.collect.ImmutableList
import ru.dbotthepony.kstarbound.defs.DirectAssetReference
import ru.dbotthepony.kstarbound.defs.item.api.IArmorItemDefinition
import ru.dbotthepony.kstarbound.defs.item.LeveledStatusEffect
import ru.dbotthepony.kstarbound.io.json.builder.JsonBuilder

@JsonBuilder
abstract class ArmorItemPrototype : ItemPrototype(), IArmorItemDefinition {
	final override var colorOptions: ImmutableList<Map<String, String>> by NotNull(ImmutableList.of())
	final override var maleFrames: IArmorItemDefinition.Frames by NotNull()
	final override var femaleFrames: IArmorItemDefinition.Frames by NotNull()
	final override var level: Double by NotNull(1.0)
	final override var leveledStatusEffects: ImmutableList<LeveledStatusEffect> by NotNull(ImmutableList.of())

	final override var scripts: ImmutableList<DirectAssetReference> by NotNull(ImmutableList.of())
	final override var scriptDelta: Int by NotNull(1)

	init {
		maxStack = 1L
	}
}

@JsonBuilder
class HeadArmorItemPrototype : ArmorItemPrototype() {
	override val itemType: String
		get() = "headarmor"
}

@JsonBuilder
class ChestArmorItemPrototype : ArmorItemPrototype() {
	override val itemType: String
		get() = "chestarmor"
}

@JsonBuilder
class LegsArmorItemPrototype : ArmorItemPrototype() {
	override val itemType: String
		get() = "legsarmor"
}

@JsonBuilder
class BackArmorItemPrototype : ArmorItemPrototype() {
	override val itemType: String
		get() = "backarmor"
}
